var days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var month = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
var current = null;
var now = new Date();
var isSmall = false;

function setup() {
  if (window.widget) {
    widgetSetup();
    var daySelect = document.getElementById("DaySelect");
    for (var i = 1; i < 32; i++) {
      var option = document.createElement("option");
      option.innerHTML = i;
      daySelect.appendChild(option);    	
    }
    var monthSelect = document.getElementById("MonthSelect");
    for (var i = 0; i < month.length; i++) {
      var option = document.createElement("option");
      option.innerHTML = month[i];
      monthSelect.appendChild(option);
    }
    var yearSelect = document.getElementById("YearSelect");
    for (var i = 2000; i < 2020; i++) {
      var option = document.createElement("option");
      option.innerHTML = i;
      yearSelect.appendChild(option);    	
    }
    readPrefs();
    widget.onshow = startTimeout;
    if (!widget.context) {
      document.getElementById("Widgetop").style.display = "block";
    }
  }
}

function setDate(date) {
  date = cleanDate(date);  
  document.getElementById("Day").innerHTML = date.getDate();
  document.getElementById("DayShadow").innerHTML = date.getDate();
  document.getElementById("Year").innerHTML = date.getFullYear();
  document.getElementById("DayOfWeek").innerHTML = days[date.getDay()];
  if (date.getDay() == 0) {
    document.getElementById("Day").style.color = "#C00000";
  }
  else {
    document.getElementById("Day").style.color = "black";    
  }
  document.getElementById("Month").innerHTML = month[date.getMonth()];
  document.getElementById("DaySelect").selectedIndex = date.getDate() - 1;
  document.getElementById("MonthSelect").selectedIndex = date.getMonth();
  document.getElementById("YearSelect").selectedIndex = date.getFullYear() - 2000;
  current = date;
  if (date < now) {
    document.getElementById("Page").style.backgroundColor = "#E0E0FF";
    document.getElementById("Today").style.display = "block";
    document.getElementById("Today").innerHTML = "Today &gt;";
  } 
  else if (date > now) {
    document.getElementById("Page").style.backgroundColor = "#E0FFE0";
    document.getElementById("Today").style.display = "block";
    document.getElementById("Today").innerHTML = "&lt; Today";
  }
  else {
    document.getElementById("Page").style.backgroundColor = "white";    
    document.getElementById("Today").style.display = "none";
  }
}

function cleanDate(date) {
  return new Date(date.getFullYear(), date.getMonth(), date.getDate());  
}

function yesterday() {
  current = new Date(current.getFullYear(), current.getMonth(), current.getDate() - 1);
  setDate(current);
}

function tomorrow() {
  current = new Date(current.getFullYear(), current.getMonth(), current.getDate() + 1);
  setDate(current);
}

function today() {
  setDate(new Date());
}

function wikipedia() {
  widget.openURL("http://en.wikipedia.org/wiki/" + month[current.getMonth()] + "_" + current.getDate());
}

function dayChanged() {
  var day = document.getElementById("DaySelect").selectedIndex;
  current.setDate(day + 1);
  setDate(current);
}

function monthChanged() {
  var month = document.getElementById("MonthSelect").selectedIndex;
  current.setMonth(month);
  setDate(current);
}

function yearChanged() {
  var year = document.getElementById("YearSelect").selectedIndex + 2000;
  current.setFullYear(year);
  setDate(current);
}

function startTimeout() {
  now = new Date();
  var tomorrow = new Date();
  tomorrow.setDate(tomorrow.getDate() + 1);
  tomorrow = cleanDate(tomorrow);
  setTimeout(startTimeout, tomorrow.getTime() - new Date().getTime());
  now = cleanDate(now); 
  today();
}

function changeSize(small) {
  if (small) {
    document.getElementById("SizeCss").href = "daySmall.css";
    window.resizeTo(120, 140);
  }
  else {
    document.getElementById("SizeCss").href = "dayNormal.css";
    window.resizeTo(200, 214);    
  }
}

function readPrefs() {
  var value = widget.preferenceForKey(widget.identifier + "-small");
  isSmall = value == "true";
  changeSize(isSmall);
  document.getElementById("SmallSize").checked = isSmall;
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-small");
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "black", "black", showBack);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    window.resizeTo(220, 220);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    isSmall = document.getElementById("SmallSize").checked;
    changeSize(isSmall);
    widget.setPreferenceForKey(isSmall + "", widget.identifier + "-small");
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}  